﻿using Microsoft.EntityFrameworkCore;

namespace synonyms_demo.Models
{
    public class SynonymsDbContext : DbContext
    {
        public DbSet<SynonymEntryModel> SynonymEntries { get; set; }

        public SynonymsDbContext(DbContextOptions<SynonymsDbContext> options) : base(options)
        {
        }

        //Database model configuration
        //While in this case default values should do fine, it is often better to be more explicit
        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<SynonymEntryModel>().HasKey(p => p.Id);
            modelBuilder.Entity<SynonymEntryModel>().Property(p => p.Id).UseSqlServerIdentityColumn();
            modelBuilder.Entity<SynonymEntryModel>().Property(p => p.Term).HasMaxLength(64);
            modelBuilder.Entity<SynonymEntryModel>().Property(p => p.Synonyms).HasMaxLength(512);

            modelBuilder.Entity<SynonymEntryModel>().HasIndex(p => p.Term);

            //when seeding data even autogenerated Id values need to be specified
            modelBuilder.Entity<SynonymEntryModel>().HasData(new SynonymEntryModel() { Id = 1, Term = "computer", Synonyms = "laptop,notebook" });
            modelBuilder.Entity<SynonymEntryModel>().HasData(new SynonymEntryModel() { Id = 2, Term = "computer", Synonyms = "notebook,pc" });
            modelBuilder.Entity<SynonymEntryModel>().HasData(new SynonymEntryModel() { Id = 3, Term = "computer", Synonyms = "workstation" });
            modelBuilder.Entity<SynonymEntryModel>().HasData(new SynonymEntryModel() { Id = 4, Term = "notebook", Synonyms = "computer,portable-computer" });
        }
    }
}

